package lib.ui;

import lib.ScreenPos;
import kernel.ButtonType;

using tink.CoreApi;

typedef UIEvents = {
	public var ?onClick:Callback<{button:ButtonType, pos:ScreenPos}>;
	public var ?onKey:Callback<{keyCode:Int, isHeld:Bool}>;
	public var ?onKeyUp:Callback<Int>;
	public var ?onMouseDrag:Callback<{button:ButtonType, pos:ScreenPos}>;
	public var ?onMouseScroll:Callback<{dir:Int, pos:ScreenPos}>;
	public var ?onMouseUp:Callback<{button:ButtonType, pos:ScreenPos}>;
	public var ?onPaste:Callback<String>;
	public var ?onChar:Callback<String>;
}
